"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.findSelectedNodeOfType = exports.equalNodeType = exports.isWholeSelection = exports.isNodeSelection = exports.isTextSelection = void 0;
const prosemirror_state_1 = require("prosemirror-state");
const isTextSelection = (selection) => 
// for some reason "instanceof" sometimes returns false
selection.constructor.name === prosemirror_state_1.TextSelection.prototype.constructor.name;
exports.isTextSelection = isTextSelection;
const isNodeSelection = (selection) => 
// for some reason "instanceof" sometimes returns false
selection.constructor.name === prosemirror_state_1.NodeSelection.prototype.constructor.name;
exports.isNodeSelection = isNodeSelection;
// ts broke down when use "selection is AllSelection" return type
// maybe because AllSelection has same class type with different constructor
const isWholeSelection = (selection) => 
// for some reason "instanceof" sometimes returns false
selection.constructor.name === prosemirror_state_1.AllSelection.prototype.constructor.name;
exports.isWholeSelection = isWholeSelection;
const equalNodeType = function equalNodeType(nodeType, node) {
    return (Array.isArray(nodeType) && nodeType.indexOf(node.type) > -1) || node.type === nodeType;
};
exports.equalNodeType = equalNodeType;
const findSelectedNodeOfType = (nodeType) => {
    return function (selection) {
        if ((0, exports.isNodeSelection)(selection)) {
            const node = selection.node, $from = selection.$from;
            if ((0, exports.equalNodeType)(nodeType, node)) {
                return { node: node, pos: $from.pos, depth: $from.depth };
            }
        }
        return null;
    };
};
exports.findSelectedNodeOfType = findSelectedNodeOfType;
