import { TextSelection, NodeSelection, AllSelection } from 'prosemirror-state';
export const isTextSelection = (selection) => 
// for some reason "instanceof" sometimes returns false
selection.constructor.name === TextSelection.prototype.constructor.name;
export const isNodeSelection = (selection) => 
// for some reason "instanceof" sometimes returns false
selection.constructor.name === NodeSelection.prototype.constructor.name;
// ts broke down when use "selection is AllSelection" return type
// maybe because AllSelection has same class type with different constructor
export const isWholeSelection = (selection) => 
// for some reason "instanceof" sometimes returns false
selection.constructor.name === AllSelection.prototype.constructor.name;
export const equalNodeType = function equalNodeType(nodeType, node) {
    return (Array.isArray(nodeType) && nodeType.indexOf(node.type) > -1) || node.type === nodeType;
};
export const findSelectedNodeOfType = (nodeType) => {
    return function (selection) {
        if (isNodeSelection(selection)) {
            const node = selection.node, $from = selection.$from;
            if (equalNodeType(nodeType, node)) {
                return { node: node, pos: $from.pos, depth: $from.depth };
            }
        }
        return null;
    };
};
